"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useConnectionCheck = void 0;

var _react = require("react");

var _connectionChecker = require("../connection-checker");

var _extended = require("../client/extended");

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(n); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var useConnectionCheck = function useConnectionCheck(channelRid, maxAbsence) {
  var running = (0, _react.useRef)();
  var unsubscribe = (0, _react.useRef)();

  var _useState = (0, _react.useState)(undefined),
      _useState2 = _slicedToArray(_useState, 2),
      connStatus = _useState2[0],
      setConnStatus = _useState2[1];

  var connectionRef = (0, _react.useRef)((0, _connectionChecker.getConnectionChecker)(setConnStatus));
  var _connectionRef$curren = connectionRef.current,
      check = _connectionRef$curren.check,
      bump = _connectionRef$curren.bump;
  (0, _react.useEffect)(function () {
    if (!channelRid || !maxAbsence) return undefined;
    (0, _extended.fromChannel)({
      rid: channelRid,
      last: true,
      cb: bump,
      path: 'ts'
    }).then(function (unsub) {
      return unsubscribe.current = unsub;
    });
    running.current = setInterval(function () {
      return check(maxAbsence);
    }, 2000);
    return function () {
      if (unsubscribe.current) unsubscribe.current();

      if (running.current) {
        clearInterval(running.current);
        running.current = undefined;
      }
    };
  }, [channelRid, maxAbsence]);
  return connStatus;
};

exports.useConnectionCheck = useConnectionCheck;