"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Table = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames3 = _interopRequireDefault(require("classnames"));

var _core = require("@material-ui/core");

var _Divider = _interopRequireDefault(require("@material-ui/core/Divider"));

var _Table = _interopRequireDefault(require("@material-ui/core/Table"));

var _TableBody = _interopRequireDefault(require("@material-ui/core/TableBody"));

var _TableRow = _interopRequireDefault(require("@material-ui/core/TableRow"));

var _TableCell = _interopRequireDefault(require("@material-ui/core/TableCell"));

var _uiUtils = require("../ui-utils");

var _transforms = require("../transforms");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var useStyles = (0, _core.makeStyles)(function (theme) {
  return {
    tableContainer: {
      overflowY: 'auto',
      height: '100%',
      width: '100%'
    },
    wordBreak: {
      wordBreak: 'break-all'
    },
    lesserRightPadding: {
      paddingRight: theme.spacing(1)
    },
    bold: {
      fontWeight: 'bold'
    }
  };
});
var propTypes = {
  data: _propTypes["default"].objectOf(_propTypes["default"].any),
  style: _propTypes["default"].objectOf(_propTypes["default"].any),
  point: _propTypes["default"].objectOf(_propTypes["default"].any)
};
var defaultProps = {
  style: {},
  data: {},
  point: undefined
};

var Table = function Table(_ref) {
  var style = _ref.style,
      data = _ref.data,
      point = _ref.point,
      boldValue = _ref.boldValue;
  var classes = useStyles();
  var theData = point || data;
  if ((0, _transforms.nilOrEmpty)(theData)) return null;
  return /*#__PURE__*/_react["default"].createElement("div", {
    style: style,
    className: classes.tableContainer
  }, /*#__PURE__*/_react["default"].createElement(_Divider["default"], null), /*#__PURE__*/_react["default"].createElement(_Table["default"], null, /*#__PURE__*/_react["default"].createElement(_TableBody["default"], null, Object.keys(theData).map(function (key) {
    var _classnames2;

    return /*#__PURE__*/_react["default"].createElement(_TableRow["default"], {
      key: key
    }, /*#__PURE__*/_react["default"].createElement(_TableCell["default"], {
      className: (0, _classnames3["default"])(_defineProperty({}, classes.lesserRightPadding, true))
    }, key), /*#__PURE__*/_react["default"].createElement(_TableCell["default"], {
      className: (0, _classnames3["default"])((_classnames2 = {}, _defineProperty(_classnames2, classes.wordBreak, true), _defineProperty(_classnames2, classes.bold, boldValue), _classnames2))
    }, (0, _uiUtils.prettyPrint)(theData[key])));
  }))));
};

exports.Table = Table;
Table.propTypes = propTypes;
Table.defaultProps = defaultProps;