"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ThresholdGaugeTS = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _core = require("@material-ui/core");

var _Tooltip = _interopRequireDefault(require("@material-ui/core/Tooltip"));

var _formatDistance = _interopRequireDefault(require("date-fns/fp/formatDistance"));

var _transforms = require("../transforms");

var _Caption = require("./Caption");

var _ThresholdGauge = require("./ThresholdGauge");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(n); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var useStyles = (0, _core.makeStyles)(function () {
  return {
    center: {
      textAlign: 'center'
    },
    flexCenter: {
      justifyContent: 'center',
      display: 'flex',
      flexDirection: 'column'
    }
  };
});
var propTypes = {
  msg: _propTypes["default"].objectOf(_propTypes["default"].any),
  // Backward compatibility
  point: _propTypes["default"].objectOf(_propTypes["default"].any),
  style: _propTypes["default"].objectOf(_propTypes["default"].any),
  gaugeStyle: _propTypes["default"].objectOf(_propTypes["default"].any),
  path: _propTypes["default"].string // ThresholdGaugeProps: PropTypes.objectOf(PropTypes.any),

};
var defaultPoint = {};
var defaultStyle = {};
var defaultGaugeStyle = {}; // const defaultProps = {
//   path: '',
//   point: undefined,
//   msg: undefined,
//   style: {},
//   gaugeStyle: {},
//   // ThresholdGaugeProps: {},
// };

var ThresholdGaugeTS = function ThresholdGaugeTS(_ref) {
  var msg = _ref.msg,
      point = _ref.point,
      _ref$path = _ref.path,
      path = _ref$path === void 0 ? 'pl[0]' : _ref$path,
      _ref$style = _ref.style,
      style = _ref$style === void 0 ? defaultStyle : _ref$style,
      _ref$gaugeStyle = _ref.gaugeStyle,
      gaugeStyle = _ref$gaugeStyle === void 0 ? defaultGaugeStyle : _ref$gaugeStyle,
      rest = _objectWithoutProperties(_ref, ["msg", "point", "path", "style", "gaugeStyle"]);

  var classes = useStyles();
  var timer = (0, _react.useRef)();

  var _useState = (0, _react.useState)(0),
      _useState2 = _slicedToArray(_useState, 2),
      setTrigger = _useState2[1];

  var pointOnly = point || msg || defaultPoint;
  var ts = pointOnly.ts;
  (0, _react.useEffect)(function () {
    if (!ts) return undefined;
    timer.current = setInterval(function () {
      return setTrigger(function (x) {
        return x + 1;
      });
    }, 60000);
    return function () {
      return clearInterval(timer.current);
    };
  }, [ts]);

  var timeLabel = /*#__PURE__*/_react["default"].createElement(_Caption.Caption, {
    label: "Data age: ".concat(ts ? (0, _formatDistance["default"])(new Date())(ts) : '-')
  });

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: classes.flexCenter,
    style: style
  }, /*#__PURE__*/_react["default"].createElement(_ThresholdGauge.ThresholdGauge, _extends({
    value: (0, _transforms.getPath)(path, pointOnly),
    style: gaugeStyle
  }, rest)), /*#__PURE__*/_react["default"].createElement("div", {
    className: classes.center
  }, ts ? /*#__PURE__*/_react["default"].createElement(_Tooltip["default"], {
    title: ts.toISOString()
  }, /*#__PURE__*/_react["default"].createElement("span", null, timeLabel)) : timeLabel));
};

exports.ThresholdGaugeTS = ThresholdGaugeTS;
ThresholdGaugeTS.propTypes = propTypes;