"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ValueDisplay = void 0;

var _react = _interopRequireWildcard(require("react"));

var _core = require("@material-ui/core");

var _propTypes = _interopRequireDefault(require("prop-types"));

var R = _interopRequireWildcard(require("ramda"));

var _Tooltip = _interopRequireDefault(require("@material-ui/core/Tooltip"));

var _formatDistance = _interopRequireDefault(require("date-fns/fp/formatDistance"));

var _transforms = require("../transforms");

var _Caption = require("./Caption");

var _Table = require("./Table");

var _uiUtils = require("../ui-utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(n); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function textStyleFromText(str, size) {
  var fontSize = Math.max(18, 90 - str.length * 2.1 - size * 15);
  return {
    fontSize: fontSize
  };
}

var propTypes = {
  style: _propTypes["default"].objectOf(_propTypes["default"].any),
  point: _propTypes["default"].shape({
    ts: _propTypes["default"].date,
    pl: _propTypes["default"].arrayOf(_propTypes["default"].any)
  }),
  config: _propTypes["default"].arrayOf(_propTypes["default"].any) // bgOffset: PropTypes.number,

};
var defaultPoint = {};
var defaultPl = [];
var defaultConfig = [];

var ValueDisplay = function ValueDisplay(_ref) {
  var style = _ref.style,
      _ref$config = _ref.config,
      config = _ref$config === void 0 ? defaultConfig : _ref$config,
      _ref$point = _ref.point,
      point = _ref$point === void 0 ? defaultPoint : _ref$point;
  // TODO: Handle units implicitly?
  var ts = point.ts,
      _point$pl = point.pl,
      pl = _point$pl === void 0 ? defaultPl : _point$pl;

  var _ensureArray = (0, _transforms.ensureArray)(config),
      _ensureArray$length = _ensureArray.length,
      confCount = _ensureArray$length === void 0 ? 0 : _ensureArray$length;

  var _pl$length = pl.length,
      valCount = _pl$length === void 0 ? 0 : _pl$length;
  var configs = (0, _react.useMemo)(function () {
    return valCount > confCount ? [].concat(_toConsumableArray(config), _toConsumableArray(Array(valCount - confCount).fill({}))) : config;
  }, [valCount, confCount, config]);

  var timeLabel = /*#__PURE__*/_react["default"].createElement(_Caption.Caption, {
    label: "Data age: ".concat(ts ? (0, _formatDistance["default"])(new Date())(ts) : '-')
  });

  var data = (0, _react.useMemo)(function () {
    return R.addIndex(R.map)(function () {
      var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref2$unit = _ref2.unit,
          unit = _ref2$unit === void 0 ? '' : _ref2$unit,
          transform = _ref2.transform,
          decimals = _ref2.decimals,
          toFloor = _ref2.floor,
          label = _ref2.label,
          precision = _ref2.precision,
          ltOnePrecision = _ref2.ltOnePrecision;

      var idx = arguments.length > 1 ? arguments[1] : undefined;
      // console.log({ unit, decimals, label, idx, plIdx: pl[idx] });
      var prettifyValue = (0, _uiUtils.prettifyNumberWithOptions)(_objectSpread({
        precision: precision,
        decimals: decimals,
        toFloor: toFloor,
        ltOnePrecision: ltOnePrecision,
        notNumberTransform: function notNumberTransform(x) {
          return typeof x === 'string' ? x : (0, _uiUtils.dataToText)(x) || '-';
        }
      }, transform ? {
        ifNumberPreTransform: function ifNumberPreTransform(val) {
          try {
            return transform(val, ts, pl);
          } catch (err) {
            console.warn('ValueDisplay - transform failed. Value:', pl[idx], 'Transform:', transform, 'Error:', err);
            return val;
          }
        }
      } : {}, {
        ifNumberPostTransform: function ifNumberPostTransform(x) {
          return "".concat(x).concat(unit);
        }
      }));
      return [label || "Value ".concat(idx + 1), prettifyValue(pl[idx])];
    })(configs);
  }, [configs, pl, ts]);
  return /*#__PURE__*/_react["default"].createElement(_core.Box, {
    style: style,
    display: "flex",
    width: "100%",
    flexDirection: "column",
    alignItems: "stretch"
  }, /*#__PURE__*/_react["default"].createElement(_core.Box, {
    flexGrow: 1,
    display: "flex",
    flexDirection: "column",
    justifyContent: "center",
    alignItems: "center",
    css: {
      overflowY: 'auto'
    }
  }, data.length > 4 ? /*#__PURE__*/_react["default"].createElement(_Table.Table, {
    point: R.fromPairs(data),
    boldValue: true
  }) : data.map(function (_ref3, ix) {
    var _ref4 = _slicedToArray(_ref3, 2),
        label = _ref4[0],
        value = _ref4[1];

    return /*#__PURE__*/_react["default"].createElement(_core.Box, {
      key: label || ix // className={classes.box}
      ,
      css: {
        marginBottom: Math.max(10, 30 - data.length * 8),
        textAlign: 'center'
      }
    }, /*#__PURE__*/_react["default"].createElement("span", {
      style: textStyleFromText(value, data.length)
    }, value), /*#__PURE__*/_react["default"].createElement("br", null), /*#__PURE__*/_react["default"].createElement(_Caption.Caption, {
      label: label
    }));
  })), /*#__PURE__*/_react["default"].createElement(_core.Divider, null), /*#__PURE__*/_react["default"].createElement(_core.Box, {
    p: 1,
    height: 48,
    display: "inline-flex",
    justifyContent: "space-between",
    alignItems: "center"
  }, /*#__PURE__*/_react["default"].createElement(_core.Box, null, ts ? /*#__PURE__*/_react["default"].createElement(_Tooltip["default"], {
    title: ts.toISOString()
  }, /*#__PURE__*/_react["default"].createElement("span", null, timeLabel)) : timeLabel)));
};

exports.ValueDisplay = ValueDisplay;
ValueDisplay.propTypes = propTypes;