"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Widget = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _core = require("@material-ui/core");

var _useErrorBoundary2 = require("use-error-boundary");

var _Card = _interopRequireDefault(require("@material-ui/core/Card"));

var _CardHeader = _interopRequireDefault(require("@material-ui/core/CardHeader"));

var _CardContent = _interopRequireDefault(require("@material-ui/core/CardContent"));

var _ListItemIcon = _interopRequireDefault(require("@material-ui/core/ListItemIcon"));

var _ListItemText = _interopRequireDefault(require("@material-ui/core/ListItemText"));

var _Menu = _interopRequireDefault(require("@material-ui/core/Menu"));

var _MenuItem = _interopRequireDefault(require("@material-ui/core/MenuItem"));

var _IconButton = _interopRequireDefault(require("@material-ui/core/IconButton"));

var _Icon = _interopRequireDefault(require("@material-ui/core/Icon"));

var _Tooltip = _interopRequireDefault(require("@material-ui/core/Tooltip"));

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var _FlexIcon = require("./FlexIcon");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(n); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var contentHeight = 332;
var titlePadding = 16;
var titleHeight = 64;
var settingsIconSize = 48;
var tooltipIconSize = 30;
var useStyles = (0, _core.makeStyles)(function () {
  return {
    card: {
      position: 'relative',
      display: 'inline-grid',
      // '&:last-child': { marginBottom: theme.spacing(1) },
      gridTemplateRows: "".concat(titleHeight, "px auto") // enforce title height

    },
    tooltipContainer: {
      position: 'absolute',
      // right: 48,
      top: 8
    },
    tooltipBody: {
      maxWidth: 180
    },
    cardContentRoot: {
      '&:last-child': {
        paddingBottom: 0
      }
    },
    cardContent: {
      width: '100%',
      padding: 0,
      display: 'flex',
      justifyContent: 'center'
    },
    title: {
      overflow: 'hidden',
      textOverflow: 'ellipsis',
      whiteSpace: 'nowrap'
    },
    settingsMenu: {
      position: 'absolute',
      top: titleHeight / 2 - settingsIconSize / 2
    },
    tooltip: {
      position: 'absolute',
      top: titleHeight / 2 - tooltipIconSize / 2
    }
  };
});
var propTypes = {
  // classes: PropTypes.objectOf(PropTypes.any).isRequired,
  contentStyle: _propTypes["default"].objectOf(_propTypes["default"].any),
  width: _propTypes["default"].number.isRequired,
  height: _propTypes["default"].number,
  title: _propTypes["default"].string,
  tooltip: _propTypes["default"].string,
  children: _propTypes["default"].node.isRequired,
  // settingsCallback: PropTypes.func,
  menuItems: _propTypes["default"].arrayOf(_propTypes["default"].object),
  style: _propTypes["default"].objectOf(_propTypes["default"].any)
};
var defaultProps = {
  style: {},
  contentStyle: {},
  title: 'Untitled',
  height: contentHeight,
  // settingsCallback: () => {},
  menuItems: undefined,
  tooltip: undefined
};

var Widget = function Widget(_ref) {
  var title = _ref.title,
      tooltip = _ref.tooltip,
      width = _ref.width,
      height = _ref.height,
      children = _ref.children,
      menuItems = _ref.menuItems,
      style = _ref.style,
      contentStyle = _ref.contentStyle;
  var classes = useStyles();

  var _useErrorBoundary = (0, _useErrorBoundary2.useErrorBoundary)(),
      ErrorBoundary = _useErrorBoundary.ErrorBoundary,
      didCatch = _useErrorBoundary.didCatch;

  var _useState = (0, _react.useState)(),
      _useState2 = _slicedToArray(_useState, 2),
      anchorEl = _useState2[0],
      setAnchorEl = _useState2[1]; // const [hasError, setHasError] = useState(false);
  // const handleMenuClose = setAnchorEl;


  var handleMenuItem = function handleMenuItem(method) {
    return function () {
      method();
      setAnchorEl();
    };
  };

  var handleMenuClick = (0, _react.useCallback)(function (e) {
    e.stopPropagation();
    setAnchorEl(e.currentTarget);
  }, []);
  var titleWidth = width - titlePadding - (tooltip ? settingsIconSize + tooltipIconSize : settingsIconSize);
  var titleFontSize = "".concat(title.length >= 20 && width < 400 ? 1.5 - (title.length - 20) / 30 : 1.5, "rem");
  return /*#__PURE__*/_react["default"].createElement(_Card["default"], {
    className: classes.card,
    style: _objectSpread({
      height: (height || contentHeight) + titleHeight,
      width: width
    }, style)
  }, /*#__PURE__*/_react["default"].createElement(_CardHeader["default"], {
    classes: {
      title: classes.title
    },
    style: {
      maxWidth: titleWidth
    },
    title: /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
      variant: "h5",
      noWrap: true,
      style: {
        maxWidth: titleWidth,
        fontSize: titleFontSize
      }
    }, title),
    action: menuItems && /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
      "aria-label": "widget-button",
      "aria-owns": anchorEl ? 'widget-menu' : null,
      "aria-haspopup": "true",
      disabled: didCatch,
      onClick: handleMenuClick,
      className: classes.settingsMenu,
      style: {
        left: width - settingsIconSize
      }
    }, /*#__PURE__*/_react["default"].createElement(_FlexIcon.FlexIcon, {
      icon: "more_vert"
    })), /*#__PURE__*/_react["default"].createElement(_Menu["default"], {
      id: "widget-menu",
      anchorEl: anchorEl,
      open: !!anchorEl,
      onClose: function onClose() {
        return setAnchorEl();
      },
      transitionDuration: 100
    }, menuItems.map(function (conf) {
      return /*#__PURE__*/_react["default"].createElement(_MenuItem["default"], {
        key: conf.label,
        onClick: handleMenuItem(conf.method)
      }, /*#__PURE__*/_react["default"].createElement(_ListItemIcon["default"], null, /*#__PURE__*/_react["default"].createElement(_FlexIcon.FlexIcon, {
        icon: conf.icon,
        color: "action"
      })), /*#__PURE__*/_react["default"].createElement(_ListItemText["default"], {
        primary: conf.label
      }));
    })))
  }), tooltip && /*#__PURE__*/_react["default"].createElement(_Tooltip["default"], {
    id: "".concat(title, "WidgetTooltip"),
    title: /*#__PURE__*/_react["default"].createElement("div", {
      className: classes.tooltipBody
    }, tooltip),
    placement: "bottom-end"
  }, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
    className: classes.tooltipContainer,
    style: {
      right: menuItems ? 48 : 8
    }
  }, /*#__PURE__*/_react["default"].createElement(_Icon["default"], null, "help_outline"))), /*#__PURE__*/_react["default"].createElement(_CardContent["default"], {
    className: classes.cardContent,
    classes: {
      root: classes.cardContentRoot
    },
    style: _objectSpread({
      width: width
    }, contentStyle)
  }, /*#__PURE__*/_react["default"].createElement(ErrorBoundary, null, didCatch ? /*#__PURE__*/_react["default"].createElement("h4", null, "Something went wrong.") : children))); // <Divider />
};

exports.Widget = Widget;
Widget.propTypes = propTypes;
Widget.defaultProps = defaultProps;